#include <stdio.h>
#include <string.h>
#include <algorithm>

using namespace std;

#define ABS(a)		(((a)<0)?(-(a)):(a))
#define EPS		1e-1

struct __wart {
    int v;
    char jedn[20];
    int jedn_id;
} _wart;

struct __x {
    int no;
    int ans;
    int v;
    char jedn[20];
    long double z;
} _x;

int p, w, q;
struct __wart prz[3][2];
int jedn_count;
char jedn[4][20];
int jedn_o;
long double pr[4][4];
struct __x wt[100000];
struct __x qt[100000];
int at[100000];

inline int operator < ( const __x & a, const __x & b ) { return a.z < b.z; }

int id_jedn( char *s );

void gen_pr()
{
    int i, j, k, l;

    jedn_count=0;
    for (i=0;i<p;i++)
	for (j=0;j<2;j++)
	    if (id_jedn(prz[i][j].jedn)==-1)
		strcpy(jedn[jedn_count++],prz[i][j].jedn);
    for (i=0;i<p;i++)
	for (j=0;j<2;j++)
	    prz[i][j].jedn_id=id_jedn(prz[i][j].jedn);
    
    for (i=0;i<jedn_count;i++)
	for (j=0;j<jedn_count;j++)
	    pr[i][j]=0.0;
    for (i=0;i<jedn_count;i++)
        pr[i][i]=1.0;
    for (i=0;i<p;i++) {
	pr[prz[i][0].jedn_id][prz[i][1].jedn_id]=prz[i][1].v;
	pr[prz[i][1].jedn_id][prz[i][0].jedn_id]=1.0/((long double)prz[i][1].v);
    }
    
    for (i=0;i<jedn_count;i++)
        for (j=0;j<jedn_count;j++)
	    for (k=0;k<jedn_count;k++)
		if (j!=k)
	        for (l=0;l<jedn_count;l++)
		    if (j!=l&&k!=l)
		    if (pr[j][k]!=0.0&&pr[k][l]!=0.0&&pr[j][l]==0.0)
			pr[j][l]=pr[j][k]*pr[k][l];
			
    for (i=0;i<jedn_count;i++) {
	k=1;
	for (j=0;j<jedn_count;j++)
	    if (pr[j][i]<1.0)
		k=0;
	if (k)
	    jedn_o=i;	
    }
    
    
/*
    for (i=0;i<jedn_count;i++) {
	printf("%10s ",jedn[i]);
	for (j=0;j<jedn_count;j++)
	    printf("%10.10llf ",pr[i][j]);
	printf("\n");
    }
*/
}

int id_jedn( char *s ) 
{
    int i;
    
    for (i=0;i<jedn_count;i++)
	if (!strcmp(s,jedn[i]))
	    return i;
    return -1;    
}

int main()
{
    int nsets;
    int i, j, k;
    char s[20];
    long double x, y;
    
    
    scanf("%d",&nsets);
    while (nsets--) {
	scanf("%d",&p);
//	printf("%d\n",p);
	for (i=0;i<p;i++) {
	    scanf("%d%s%s%d%s",&prz[i][0].v,prz[i][0].jedn,s,
		    &prz[i][1].v,prz[i][1].jedn);
//	    printf("%d %s = %d %s\n",prz[i][0].v,prz[i][0].jedn,
//		    prz[i][1].v,prz[i][1].jedn);
	}

        gen_pr();
	    
        scanf("%d",&w);
        for (i=0;i<w;i++) {
	    scanf("%d%s",&wt[i].v,&wt[i].jedn);
	    wt[i].z=((long double)wt[i].v)*pr[id_jedn(wt[i].jedn)][jedn_o];
//	    printf("%d %s = %llf\n",wt[i].v,wt[i].jedn,wt[i].z);
	}
	scanf("%d",&q);
	for (i=0;i<q;i++) {
	    scanf("%d%s",&qt[i].v,&qt[i].jedn);
	    qt[i].z=((long double)qt[i].v)*pr[id_jedn(qt[i].jedn)][jedn_o];
	    qt[i].no=i;
//	    printf("%d %s = %llf\n",qt[i].v,qt[i].jedn,qt[i].z);
	}
	    
	sort(wt,wt+w);
	sort(qt,qt+q);
	    
	j=0;
	for (i=0;i<q;i++) {
	    while (wt[j].z<qt[i].z&&j!=w-1) j++;
	    if (j-1>=0&&j-1<w&&
		ABS(wt[j-1].z-qt[i].z)<=ABS(wt[j].z-qt[i].z)+EPS)
		qt[i].ans=j-1;
	    else
		qt[i].ans=j;
	}
	
	for (i=0;i<q;i++)
	    at[qt[i].no]=qt[i].ans;
	for (i=0;i<q;i++)
	    printf("%d %s\n",wt[at[i]].v,wt[at[i]].jedn);
    
    }
    
    
    return 0;
}
